import java.net.*;
import java.io.*;
import java.util.*;
import java.rmi.*;
import java.rmi.server.*;

/** un proxy remoto dell'oggetto File */
public class RemoteFile extends UnicastRemoteObject implements RemoteFileI
{
   /**
    * l'oggetto "proxato"
    * @label proxy di...
    */
   protected File file;

   /** factory method, crea un nuovo oggetto che rappresenta un altro File */
   public RemoteFileI newFile(String nomeFile) throws RemoteException
   {
      RemoteFile r = new RemoteFile(nomeFile);
      System.out.println("Richiesto nuovo file:" + r);
      return r;
   }

   public RemoteFile() throws RemoteException
   {
      this("C:/temp");
   }

   public RemoteFile(String path) throws RemoteException
   {
      this(new File(path));
   }

   public RemoteFile(File file) throws RemoteException
   {
      this.file = file;
   }

   public static void main(String[] arg) throws Exception
   {
      RemoteFile r = new RemoteFile();
      Naming.bind("Root", r);
      System.out.println(r);
   }

   public String toString()
   {
      return super.toString() + " proxy di " + file.toString();
   }

   public RemoteFileI getParent() throws RemoteException
   {
      return newFile(file.getParent());
   }

   public String[] list() throws RemoteException
   {
      System.out.println("Richiesta lista files...");
      return file.list();
   }

   public InMemoryFile getContent() throws RemoteException
   {
      System.out.println("Richiesto contenuto di " + this);
      if (file.exists())
         return new InMemoryFile(file);
      else
         return null;
   }
}
